#ifndef BMP_GRAPHIC_LIB
#define BMP_GRAPHIC_LIB

#include <WINDOWS.H>
#include "types.h"

DLL_FUNC HBITMAP LoadBMPFileA(char* filename, ImageStruct* pImage);
DLL_FUNC HBITMAP LoadBMPFileW(wchar_t* filename, ImageStruct* pImage);
#ifdef UNICODE
#define LoadBMPFile LoadBMPFileW
#else
#define LoadBMPFile LoadBMPFileA
#endif

DLL_FUNC int ReadBMPHeader(FILE_HANDLE file, ImageStruct* pImage, void** HeaderInfo);
DLL_FUNC int ReadBMPData(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, void* pData);
DLL_FUNC int ReadBMPPalette(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, PALETTE* pPalette);
DLL_FUNC void DeleteBMPHeaderInfo(void* HeaderInfo);

#define	GBM_ERR_BMP_PLANES	((GBM_ERR) 0x300)
#define	GBM_ERR_BMP_BITCOUNT	((GBM_ERR) 0x301)
#define	GBM_ERR_BMP_CBFIX	((GBM_ERR) 0x302)
#define	GBM_ERR_BMP_COMP	((GBM_ERR) 0x303)
#define	GBM_ERR_BMP_OFFSET	((GBM_ERR) 0x304)

#define IMAGE_BMP	0x300

#endif //BMP_GRAPHIC_LIB