#ifndef COMMON_GRAPHIC_LIB
#define COMMON_GRAPHIC_LIB


#include "types.h"
#include "tga.h"
#include "bmp.h"
#include "gif.h"
#include "jpg.h"
#include "png.h"

DLL_FUNC int ReadImageHeader(FILE_HANDLE file, ImageStruct* pImage, void** HeaderInfo);
DLL_FUNC int ReadImageData(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, void* pData);
DLL_FUNC int ReadImagePalette(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, PALETTE* pPalette);
DLL_FUNC void DeleteImageHeaderInfo(ImageStruct* pImage, void* HeaderInfo);

DLL_FUNC HBITMAP LoadImageFileA(char* filename, ImageStruct* pImage);
DLL_FUNC HBITMAP LoadImageFileW(wchar_t* filename, ImageStruct* pImage);
#ifdef UNICODE
#define LoadImageFile LoadImageFileW
#else
#define LoadImageFile LoadImageFileA
#endif
#endif //COMMON_GRAPHIC_LIB