#include "gbio.h"
#include <windows.h>
#include <SYS\STAT.H>
#include <time.h>

//file routines
//****************************************************************
DLL_FUNC FILE_HANDLE file_openA(char* filename, BOOL bRead /* = TRUE */)
{
	DWORD dwAccess, dwShare, dwDispos;
	if (bRead)
	{
		dwAccess = GENERIC_READ;
		dwShare = FILE_SHARE_READ;
		dwDispos = OPEN_EXISTING;
	}
	else
	{
		dwAccess = GENERIC_WRITE;
		dwShare = 0;
		dwDispos = CREATE_ALWAYS;
	}

	HANDLE hFile = CreateFileA(filename, dwAccess, dwShare, NULL, dwDispos, FILE_ATTRIBUTE_NORMAL, NULL);
	return hFile;
}

DLL_FUNC FILE_HANDLE file_openW(wchar_t* filename, BOOL bRead /* = TRUE */)
{
	DWORD dwAccess, dwShare, dwDispos;
	if (bRead)
	{
		dwAccess = GENERIC_READ;
		dwShare = FILE_SHARE_READ;
		dwDispos = OPEN_EXISTING;
	}
	else
	{
		dwAccess = GENERIC_WRITE;
		dwShare = 0;
		dwDispos = CREATE_ALWAYS;
	}

	HANDLE hFile = CreateFileW(filename, dwAccess, dwShare, NULL, dwDispos, FILE_ATTRIBUTE_NORMAL, NULL);
	return hFile;
}

dword file_read(FILE_HANDLE file, void* buffer, dword size)
{
	DWORD dwRead;
	if (!ReadFile(file, buffer, size, &dwRead, NULL))
		return 0;
	return dwRead;
}

dword file_write(FILE_HANDLE file, const void* buffer, dword size)
{
	DWORD nWrite;
	if (!WriteFile(file, buffer, size, &nWrite, NULL))
		return 0;
	return nWrite;
}

dword file_seek(FILE_HANDLE file, long pos, int origin)
{
	return SetFilePointer(file, pos, NULL, origin);
}

int file_close(FILE_HANDLE file)
{
	return CloseHandle(file);
}

static int temnumber = 0;

FILE_HANDLE tmp_file()
{
	TCHAR TempPath[MAX_PATH];
	TCHAR TempFileName[MAX_PATH];
	GetTempPath(MAX_PATH, TempPath);
	GetTempFileName(TempPath, TEXT("$IMGLOAD$"), time(NULL), TempFileName);
	HANDLE hFile = CreateFile(TempFileName, FILE_ALL_ACCESS, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_TEMPORARY, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return NULL;
	return hFile;
}

AHEAD* create_ahead(FILE_HANDLE fd)
{
	AHEAD *ahead;

	ahead = new AHEAD;
	if ( ahead == NULL )
		return NULL;

	ahead->inx = 0;
	ahead->cnt = 0;
	ahead->fd  = fd;

	return ahead;
}

void destroy_ahead(AHEAD *ahead)
{
	delete ahead;
}	

int read_ahead(AHEAD *ahead)
{
	if ( ahead->inx >= ahead->cnt )
	{
		ahead->cnt = file_read(ahead->fd, (char *) ahead->buf, AHEAD_BUF);
		if ( ahead->cnt <= 0 )
			return -1;
		ahead->inx = 0;
	}
	return (int) (unsigned int) ahead->buf[ahead->inx++];
}

//*******************************************************************
