#ifndef GIF_GRAPHIC_LIB
#define GIF_GRAPHIC_LIB

#include "types.h"
#include <WINDOWS.H>

DLL_FUNC HBITMAP LoadGIFFileA(char* filename,ImageStruct* pImage);
DLL_FUNC HBITMAP LoadGIFFileW(wchar_t* filename,ImageStruct* pImage);
#ifdef UNICODE
#define LoadGIFFile LoadGIFFileW
#else
#define LoadGIFFile LoadGIFFileA
#endif
//field Options in ImageStruct store number of image to load
DLL_FUNC int ReadGIFHeader(FILE_HANDLE file, ImageStruct* pImage, void** HeaderInfo);
DLL_FUNC int ReadGIFData(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, void* pData);
DLL_FUNC int ReadGIFPalette(FILE_HANDLE file, ImageStruct* pImage, void* HeaderInfo, PALETTE* pPalette);
DLL_FUNC void DeleteGIFHeaderInfo(void* HeaderInfo);

#define GBM_ERR_GIF_BPP   ((GBM_ERR) 0x500)
#define GBM_ERR_GIF_TERM  ((GBM_ERR) 0x501)
#define GBM_ERR_GIF_CODE_SIZE ((GBM_ERR) 0x502)
#define GBM_ERR_GIF_CORRUPT ((GBM_ERR) 0x503)
#define GBM_ERR_GIF_HEADER  ((GBM_ERR) 0x504)

#define IMAGE_GIF 0x500


#endif //GIF_GRAPHIC_LIB