#include <windows.h>

#ifndef TYPES_GRAPHIC_LIB
#define TYPES_GRAPHIC_LIB

typedef int GBM_ERR;
#define	GBM_ERR_OK		((GBM_ERR) 0)
#define	GBM_ERR_MEM		((GBM_ERR) 1)
#define	GBM_ERR_NOT_SUPP	((GBM_ERR) 2)
#define	GBM_ERR_BAD_OPTION	((GBM_ERR) 3)
#define	GBM_ERR_NOT_FOUND	((GBM_ERR) 4)
#define	GBM_ERR_BAD_MAGIC	((GBM_ERR) 5)
#define	GBM_ERR_BAD_SIZE	((GBM_ERR) 6)
#define	GBM_ERR_READ		((GBM_ERR) 7)
#define	GBM_ERR_WRITE		((GBM_ERR) 8)
#define	GBM_ERR_BAD_ARG		((GBM_ERR) 9)

typedef unsigned long dword;
typedef unsigned short word;
typedef unsigned char byte;

#define FORMAT_RGB	1
#define FORMAT_BGR	2
#define FORMAT_RGBA 3
#define FORMAT_ABGR	4
#define FORMAT_BGRA	5

#define OPTIONS_FLIP 0x10000

struct ImageStruct
{
	int iWidth;
	int iHeight;
	int iBitPerPixel;
	dword dwFlags; //low byte contains color format, second byte graphic format, third options
	dword Options;
};

struct PALCOLOR
{
	byte r;
	byte g;
	byte b;
};

struct PALETTE
{
	PALCOLOR colors[256];
	int colorcount;
};
typedef HANDLE FILE_HANDLE;

#define	AHEAD_BUF 0x4000
//structure for reading data from files
struct AHEAD
{
	byte buf[AHEAD_BUF];//buffer to store data
	int inx;			//count of used data
	int cnt;			//total amount of data in buffer
	FILE_HANDLE fd;				//file descriptor
};

#ifdef IMGLOAD_EXPORTS
#define DLL_FUNC	__declspec(dllexport)
#else
#define DLL_FUNC	__declspec(dllimport)
#endif

DLL_FUNC FILE_HANDLE file_openA(char* filename, BOOL bRead = TRUE);
DLL_FUNC FILE_HANDLE file_openW(wchar_t* filename, BOOL bRead = TRUE);
#ifdef UNICODE
#define file_open file_openW
#else
#define file_open file_openA
#endif
DLL_FUNC int file_close(FILE_HANDLE file);

#endif